% PP_parser/pp_lang1_pp.ml                                                    %
%-----------------------------------------------------------------------------%


let pp_lang1_rules =

   % : (print_rule list) %

   letrec quote_quote = (\dummy0. ((\s. letrec dupl s sl =
                                           if (null sl)
                                           then []
                                           else if ((hd sl) = s)
                                                then s.s.(dupl s (tl sl))
                                                else (hd sl).(dupl s (tl sl))
                                        in (implode o (dupl s) o explode)
                                    ) dummy0))
   and destruct =
    (\dummy0. ((\ptaddl.
                   map (\(pt,add).
                           case pt
                           of (Print_node (s,[])) . (s,add)
                            | (_) . failwith `pp_lang_rules_fun`) ptaddl
                ) dummy0))
   and construct =
    (\dummy0. ((\saddl. map (\(s,add). Print_node (s,[]),add) saddl) dummy0))
   and convert =
    (\dummy0.
       ((\saddl.
            if ((length saddl) = 1)
            then [(trim_enclosing_chars [` `] # I) (hd saddl)]
            else if ((trim_enclosing_chars [` `] (fst (hd saddl))) = ``)
                 then let saddl' =
                         map (trim_trailing_chars [` `] # I) saddl
                      in  let dead_space =
                             min (map (num_of_leading_chars [` `])
                                         (filter (\s. not (s = ``))
                                             (map fst saddl')))
                          in  map (\(s,add).
                                      if (s = ``)
                                      then (s,add)
                                      else (substr dead_space
                                               ((strlen s) - dead_space)
                                                  s,add)) saddl'
                 else failwith `pp_lang_rules_fun`
         ) dummy0))
   and is_char =
    (\dummy0. ((\(l,c,u). not (((ascii_code c) < (ascii_code l)) or
                                  ((ascii_code c) > (ascii_code u)))
                ) dummy0))
   and is_ucase = (\dummy0. ((\c. is_char (`A`,c,`Z`)) dummy0))
   and is_lcase = (\dummy0. ((\c. is_char (`a`,c,`z`)) dummy0))
   and is_letter = (\dummy0. ((\c. (is_ucase c) or (is_lcase c)) dummy0))
   and is_digit = (\dummy0. ((\c. is_char (`0`,c,`9`)) dummy0))
   and is_underscore = (\dummy0. ((\c. mem c [`_`]) dummy0))
   and is_id_body =
    (\dummy0. ((\sl. if (null sl)
                     then true
                     else if (is_underscore (hd sl))
                          then if (null (tl sl))
                               then false
                               else if (is_letter (hd (tl sl))) or
                                          (is_digit (hd (tl sl)))
                                    then is_id_body (tl (tl sl))
                                    else false
                          else if (is_letter (hd sl)) or (is_digit (hd sl))
                               then is_id_body (tl sl)
                               else false
                ) dummy0))
   and not_id = (\dummy0. (((\sl. if (null sl)
                                  then true
                                  else if (is_letter (hd sl))
                                       then not (is_id_body (tl sl))
                                       else true) o explode
                            ) dummy0))
   and is_keyword =
    (\dummy0. ((\s. mem s
                     [`prettyprinter`;`rules`;`declarations`;`abbreviations`;
                      `with`;`end`;`where`;`if`;`then`;`else`;
                      `h`;`v`;`hv`;`hov`]
                ) dummy0))
   in
   [
    ((``,(Const_name (`NUM`,[(Patt_child (Var_name (`num`,[])))])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_leaf (`num`,(I))))])));
    ((``,(Const_name (`NEG`,[(Patt_child (Var_child `num`))])),(\x y. true)),
     [],(PF (H_box [((Nat 0),(PO_constant `-`));
                    ((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,(Const_name (`STRING`,[(Patt_child (Var_name (`string`,[])))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `'`));
                 ((Nat 0),(PO_leaf (`string`,(quote_quote `'`))));
                 ((Nat 0),(PO_constant `'`))])));
    ((``,(Const_name (`TERMINAL`,[(Patt_child (Var_name (`string`,[])))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `"`));
                 ((Nat 0),(PO_leaf (`string`,(quote_quote `"`))));
                 ((Nat 0),(PO_constant `"`))])));
    ((``,(Const_name (`ML_FUN`,[(Var_children `strings`)])),(\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `{`));
                 ((Nat 0),
                  (PO_format
                    (PF (V_box
                          [(((Abs 0),(Nat 0)),
                            (PO_subcall ((`strings`,
                                          (construct o
                                           (map ((quote_quote `{` # I) o
                                                 (quote_quote `}` # I))) o
                                           convert o
                                           destruct
                                           )),[])))]))));
                 ((Nat 0),(PO_constant `}`))])));
    ((``,(Const_name (`ID`,[(Patt_child (Var_name (`id`,[])))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),
                  (PO_leaf (`id`,(\s. if ((is_keyword s) or (not_id s))
                                      then (`#` ^ (quote_quote `#` s) ^ `#`)
                                      else s
                                  ))))])));
    ((``,(Const_name (`NAME_META`,[(Var_children `id`)])),(\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `***`));
                 ((Nat 0),(PO_subcall ((`id`,(I)),[])))])));
    ((``,(Const_name (`CHILD_META`,[(Var_children `id`)])),(\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `*`));
                 ((Nat 0),(PO_subcall ((`id`,(I)),[])))])));
    ((``,(Const_name (`CHILDREN_META`,[(Var_children `id`)])),(\x y. true)),
     [],(PF (H_box [((Nat 0),(PO_constant `**`));
                    ((Nat 0),(PO_subcall ((`id`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`METAVAR_LIST`,
               [(Patt_child (Var_child `metavars`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`METAVAR_LIST`,[(Patt_child (Var_child `metavar`))])))),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 0),(Abs 3),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_subcall ((`metavars`,(I)),[])));
                       ((Nat 0),(PO_constant `;`))])));
            (((Nat 0),(Abs 3),(Nat 0)),(PO_subcall ((`metavar`,(I)),[])))])));
    ((``,(Const_name (`MIN`,[(Patt_child (Var_child `num`))])),(\x y. true)),
     [],(PF (H_box [((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,(Const_name (`MAX`,[(Patt_child (Var_child `num`))])),(\x y. true)),
     [],(PF (H_box [((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,(Const_name
           (`LOOP_RANGE`,
            [(Patt_child
               (Const_name (`MIN`,[(Patt_child (Var_child `num`))])))])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_subcall ((`num`,(I)),[])));
                                   ((Nat 0),(PO_constant `..`))])));
    ((``,(Const_name
           (`LOOP_RANGE`,
            [(Patt_child
               (Const_name (`MAX`,[(Patt_child (Var_child `num`))])))])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_constant `..`));
                                   ((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,
      (Const_name
        (`LOOP_RANGE`,
         [(Patt_child (Var_child `min`));(Patt_child (Var_child `max`))])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_subcall ((`min`,(I)),[])));
                                   ((Nat 0),(PO_constant `..`));
                                   ((Nat 0),(PO_subcall ((`max`,(I)),[])))])));
    ((``,
      (Const_name (`LOOP_LINK`,[(Patt_child (Var_child `loop_range`));
                                (Patt_child (Var_child `metavar_list`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `<`));
                 ((Nat 0),(PO_subcall ((`loop_range`,(I)),[])));
                 ((Nat 0),(PO_constant `:`));
                 ((Nat 1),(PO_subcall ((`metavar_list`,(I)),[])));
                 ((Nat 0),(PO_constant `>`))])));
    ((``,(Const_name (`LOOP_LINK`,[(Var_children `metavar_list`)])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `<`));
                 ((Nat 0),(PO_subcall ((`metavar_list`,(I)),[])));
                 ((Nat 0),(PO_constant `>`))])));
    ((``,(Const_name (`LABEL`,[(Patt_child (Var_child `child_meta`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `|`));
                 ((Nat 0),(PO_subcall ((`child_meta`,(I)),[])));
                 ((Nat 0),(PO_constant `|`))])));
    ((``,(Const_name (`NODE_NAME`,[(Patt_child (Var_child `node_name`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`node_name`,(I)),[])))])));
    ((``,(Const_name (`CHILD`,[(Patt_child (Var_child `child`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`child`,(I)),[])))])));
    ((``,
      (Print_loop
        ((Const_name
           (`CHILD_LIST`,
            [(Patt_child (Var_child `children`));
             (Patt_child (Link_child ((Default,Default),[])))])),
         (Const_name (`CHILD_LIST`,[(Patt_child (Var_child `child`))])))),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 0),(Abs 3),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_subcall ((`children`,(I)),[])));
                       ((Nat 0),(PO_constant `,`))])));
            (((Nat 0),(Abs 3),(Nat 0)),(PO_subcall ((`child`,(I)),[])))])));
    ((``,(Const_name
           (`PATT_TREE`,
            [(Patt_child
               (Const_name
                 (`NODE_NAME`,[(Patt_child (Var_child `node_name`))])));
             (Patt_child (Var_child `child_list`))])),(\x y. true)),[],
     (PF (HV_box
           [(((Nat 0),(Abs 3),(Nat 0)),(PO_subcall ((`node_name`,(I)),[])));
            (((Nat 0),(Abs 3),(Nat 0)),
             (PO_format
               (PF
                 (H_box [((Nat 0),(PO_constant `(`));
                         ((Nat 0),(PO_subcall ((`child_list`,(I)),[])));
                         ((Nat 0),(PO_constant `)`))]))))])));
    ((``,(Const_name
           (`PATT_TREE`,
            [(Patt_child
               (Const_name
                 (`NODE_NAME`,[(Patt_child (Var_child `node_name`))])))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`node_name`,(I)),[])));
                 ((Nat 0),(PO_constant `()`))])));
    ((``,(Const_name (`PATT_TREE`,[(Var_children `x`)])),(\x y. true)),[],
     (PF (HV_box [(((Nat 0),(Abs 3),(Nat 0)),(PO_subcall ((`x`,(I)),[])))])));
    ((``,(Const_name (`LOOP`,[(Patt_child (Var_child `patt_tree`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `[`));
                 ((Nat 0),(PO_subcall ((`patt_tree`,(I)),[])));
                 ((Nat 0),(PO_constant `]`))])));
    ((``,(Const_name (`TEST`,[(Patt_child (Var_child `test`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`test`,(I)),[])))])));
    ((``,(Const_name (`PATTERN`,[(Patt_child (Var_child `string`));
                                 (Patt_child (Var_child `patt_tree`));
                                 (Var_children `test`)])),(\x y. true)),[],
     (PF
       (H_box
         [((Nat 0),(PO_subcall ((`string`,(I)),[])));
          ((Nat 0),(PO_constant `::`));
          ((Nat 0),
           (PO_format
             (PF (HV_box
                   [(((Nat 1),(Abs 3),(Nat 0)),
                     (PO_subcall ((`patt_tree`,(I)),[])));
                    (((Nat 1),(Abs 3),(Nat 0)),
                     (PO_expand
                       (HV_box [(((Nat 1),(Abs 3),(Nat 0)),
                                 (PO_constant `where`));
                                (((Nat 1),(Abs 3),(Nat 0)),
                                 (PO_subcall ((`test`,(I)),[])))])))]))))])));
    ((``,(Const_name (`TRANSFORM`,[(Patt_child (Var_child `transform`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`transform`,(I)),[])))])));
    ((``,(Const_name (`P_SPECIAL`,[(Patt_child (Var_child `metavar`));
                                   (Patt_child (Var_child `transform`))])),
      (\x y. true)),[],
     (PF
       (HV_box
         [(((Nat 1),(Abs 3),(Nat 0)),
           (PO_format
             (PF (H_box [((Nat 1),(PO_subcall ((`metavar`,(I)),[])));
                         ((Nat 1),(PO_constant `=`))]))));
          (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`transform`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`P_SPECIAL_LIST`,
               [(Patt_child (Var_child `p_specials`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`P_SPECIAL_LIST`,[(Patt_child (Var_child `p_special`))])))),
      (\x y. true)),[],
     (PF
       (HoV_box
         [(((Nat 1),(Abs 0),(Nat 0)),
           (PO_expand
             (H_box [((Nat 0),(PO_subcall ((`p_specials`,(I)),[])));
                     ((Nat 0),(PO_constant `;`))])));
          (((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`p_special`,(I)),[])))])))
   ] : print_rule list;;


let pp_lang1_rules_fun =

   % : (print_rule_function) %

   print_rule_fun pp_lang1_rules;;


%-----------------------------------------------------------------------------%
